constant START = time()
without trace
without warning
without type_check

include sort.e -- I suppose I should use some RDS code ;-)

sequence vDictionary
sequence vDictCnt
sequence vToken
sequence vRawToken
sequence vTokenText
sequence vCmd
sequence vTChar
sequence vCharVal
sequence vAlphaVal
sequence vOrigChars
sequence vNewChars
sequence vHashVal
sequence vIsAlpha
sequence vTopTokens
sequence vTLCounter
integer  vTIndex
integer  vRawTIndex
integer  vTokenPos
integer  vTotalTokens
integer  vIHash
integer  vFH
integer  vChar
integer  vUniqueTokens
integer  vCX
integer  vHasAlphas
integer  vTC

constant kMAXTOKENFREQ = 20  -- Maximum number of 'top' tokens to display.
constant kMAXLEN       = 21  -- Maximum token effective length (plus 1).
constant kQUOTE        = 39  -- ASCII value for a single quote.
constant kHYPHEN       = 45  -- ASCII value for a hyphen (dash).

with trace
procedure StoreToken()
    -- Tokens must have an effective length >= 1 and <= 20 and 
    -- must not start or end with a hyphen.
    if vHasAlphas > 0 and vTIndex <= kMAXLEN and
       vRawToken[1] != kHYPHEN and vRawToken[vRawTIndex] != kHYPHEN then
        -- Accume token length frequency
        vTLCounter[vTIndex] += 1
        -- Pull out the token text
        vTokenText = vToken[1..vTIndex]
        
        -- Calculate hash value. It is based on the first two
        -- token characters and the last two characters and the
        -- effective length. --
        
        if vTIndex = 2 then
            -- Ensure that a we have a known 2nd-char value for tokens with only one char.
            vCX = 3
            vToken[3] = 1
        else
            vCX = vTIndex
        end if
        -- vCX is the effective last index to the token hash calc.
        vIHash = vTIndex + 
                 vHashVal[vToken[2]] * 50653 +   -- 37^3
                 vHashVal[vToken[3]] * 1369 +    -- 37^2
                 vHashVal[vToken[vCX-1]] * 37 +  -- 37^1
                 vHashVal[vToken[vCX]]           -- 37^0
        -- Scan the list looking for the token.                     
        vTokenPos = find(vTokenText, vDictionary [vIHash])
        if vTokenPos then
            -- Found it, so just accume its frequency.
            vDictCnt [vIHash][vTokenPos] += 1
        else
            -- Not found. So add it to the list and set the freq to 1.
            vDictionary [vIHash] = append(vDictionary[vIHash], vTokenText)
            vDictCnt [vIHash] = append(vDictCnt[vIHash], 1)
            -- Must be a new unique token too!
            vUniqueTokens += 1
        end if

        -- Count the file tokens.
        vTotalTokens += 1    
        
    end if
    -- Reset the loop variables.
    vTIndex = 1
    vRawTIndex = 0
    vIHash = 0
    vHasAlphas = 0
end procedure

procedure main()
    -- Grab the command line 
    vCmd = command_line()
    
    -- Make sure I've got a file spec.
    if length(vCmd) < 3 then 
        abort(0)
    end if
    
    -- Try and open the file. If it fails just end.
    vFH = open(vCmd[3], "rb")    
    if vFH = -1 then
        abort(0)
    end if
    
    -- We are off and running. Show the user I'm doing something.
    printf(1, "Derek Parnell %s\n",{ vCmd[3]})
    
    -- Prepare the various tables and storage arrays --
    
    -- List of raw byte values
    vOrigChars  = "'qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM0123456789-"
    -- List of uppercase equivalents.
    vNewChars   = "'QWERTYUIOPASDFGHJKLZXCVBNMQWERTYUIOPASDFGHJKLZXCVBNM0123456789-"
    -- '1' for alpha token chars, 0 for non-alpha token chars.
    vIsAlpha    = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                   1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0}
    -- The raw hash values for each token char.
    vCharVal    = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,
                     1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,
                     27,28,29,30,31,32,33,34,35,36,37}
    
    -- Create lookup tables.                 
    vTChar      = repeat(0, 256)  -- This holds the case-conversion value
                                  -- for each token character. Non-token
                                  -- characters have a zero value.
    vAlphaVal    = repeat(0, 256) -- This holds a flag to identifier all
                                  -- alphabetic characters and quote. 
    vHashVal     = repeat(0, 256) -- Contains the raw hashing value of each token char.
    for i = 1 to length(vOrigChars) do
        -- Add one to raw byte value to cater for Eu's 1-based indexing.
        vCX = 1 + vOrigChars[i]
        vTChar[vCX] = vNewChars[i]
        vAlphaVal[vCX] = vIsAlpha[i]
        vHashVal[vCX] = vCharVal[i]
    end for
    
    -- A very large buffer for storing the current string.
    vToken = repeat(0,4000) -- Allow for strings up to 4000 bytes.
    vRawToken = repeat(0,4000) -- Allow for strings up to 4000 bytes.
    
    -- This is where we store tokens. It is a set of list of tokens.
    -- Each token has a hash value calculated and that is the index of
    -- the list to store the token in.
    vDictionary = repeat( {}, 1874181)
    -- This is where we store the counts for the tokens. It mirrors the dictionary.
    vDictCnt = repeat( {}, 1874181)
    
    -- Token Length Frequency Counters. Note that the first element is a dummy
    -- one and is never actually used for anything. Its just there because I
    -- didn't want to subtract one from the token's dictionary entry length.
    vTLCounter = repeat(0, kMAXLEN)
    
    -- The total number of tokens in the file.
    vTotalTokens = 0
    -- The total number of unique tokens in the file.
    vUniqueTokens = 0
    
    vTIndex = 1 -- Start at 1 'cos first element is reserved for freqcnt during sort.
    vRawTIndex = 0 
    vHasAlphas = 0 -- Currently not in a token
    vIHash = 0 -- Initial hashing value.
    
    -- Get the first file byte.
    vChar = getc(vFH)+1
    while vChar != 0 do  -- Stop when we get EOF.
        -- Convert byte to a token character
        vTC = vTChar[vChar]
        if vTC != 0 then
            -- Got a token character so add it to current string.
            vRawTIndex += 1
            vRawToken[vRawTIndex] = vTC
            if vTC != kQUOTE then -- ignore quotes
                -- Move along to next string element and store this TC
                vTIndex += 1
                vToken[vTIndex] = vTC
            end if
            -- count the number of alphas in the string.
            vHasAlphas += vAlphaVal[vChar]
            
        elsif vTIndex > 1 then
            StoreToken()
        elsif vTIndex = 1 then
            -- This catches all-quote "tokens"
            vTIndex = 1
            vRawTIndex = 0 
            vHasAlphas = 0
        end if
        -- Get the next file byte.
        vChar = getc(vFH) + 1
    end while    
    
    -- Check for the rare case of a file not ending with a new-line char.
    if vTIndex > 1 then
        StoreToken()
    end if
    -- We have finished with the file.
    close(vFH)
    -- May as well show this now.
    printf(1, "Total: %7d, Unique: %7d\n", {vTotalTokens, vUniqueTokens})
    
    -- If we have no unique tokens then don't bother trying to display them.
    if vUniqueTokens  > 0 then
        -- Now we create the list of unique tokens in a format suitable for
        -- sorting and displaying. The dictionary will have many, many empty 
        -- entries so why bother sorting those.
        vTopTokens = repeat({}, vUniqueTokens)
        vCX = 0 -- Points to next entry in top token list.
        for i = 1 to length(vDictionary) do
            if length(vDictionary[i]) then -- ignore empty dictionary entries.
                for j = 1 to length(vDictionary[i]) do
                    vCX += 1
                    -- Copy whole dictionary entry, which is {0, tokenchar, ...}
                    vTopTokens[vCX] = vDictionary[i][j]
                    -- replace 1st element with the negative freq count.
                    -- By doing this, when we sort the list, high counts
                    -- will appear first and for equal counts, the text
                    -- will be in ascending order.
                    vTopTokens[vCX][1] = -vDictCnt[i][j] 
                end for
            end if
        end for
        
        -- Now sort them for display.
        vTopTokens = sort(vTopTokens)
        
        -- Calc how many we need to show.
        vCX = floor(vUniqueTokens/1000)+1
        if vCX > kMAXTOKENFREQ then
            vCX = kMAXTOKENFREQ
        end if
        
        -- Display the correct number of lines of "top tokens"...
        for i = 1 to vCX do
            printf(1, "%02d %-20s %d\n", {i,vTopTokens[i][2..length(vTopTokens[i])], -vTopTokens[i][1]})
        end for
        
        -- Now display the Token Length frequencies. --
        -- First, find out where the largest is.
        for i = length(vTLCounter) to 1 by -1 do
            if vTLCounter[i] != 0 then
                vCX = i
                exit
            end if
        end for
        
        -- Now list them, remember that the first entry is a dummy one and never used.
        for i = 2 to vCX do
            printf(1, "%02d %d\n", {i-1, vTLCounter[i]})
        end for
    end if
end procedure

main()
-- That's all folks.
printf(1, "Elapsed time: %f\n", time() - START)


----- SPECIAL CODE TO DEBUG ----
-- Produce the full analysis table.
if find("-FULL", command_line() ) then
    for i = 1 to length(vTopTokens) do
        vTopTokens[i] = length(vTopTokens[i])-1 & vTopTokens[i]
        vTopTokens[i][2] = -vTopTokens[i][2]
    end for
    vTopTokens = sort(vTopTokens)
    for i = 1 to length(vTopTokens) do
        printf(1, "%2d %2d %-20s %d\n", {i,vTopTokens[i][1], vTopTokens[i][3..length(vTopTokens[i])], vTopTokens[i][2]})
    end for
end if
