constant START=time()

--from RDS' sort.e:
function custom_sort(integer custom_compare,sequence x)
-- Sort a sequence. A user-supplied comparison function is used
-- to compare elements. Note that this sort is not "stable", i.e.
-- elements that are considered equal might change position relative
-- to each other.
    integer gap, j, first, last
    object tempi, tempj

    last = length(x)
    gap = floor(last / 10) + 1
    while 1 do
	first = gap + 1
	for i = first to last do
	    tempi = x[i]
	    j = i - gap
	    while 1 do
		tempj = x[j]
        if call_func(custom_compare,{tempi,tempj})>=0 then
		    j += gap
		    exit
		end if
		x[j+gap] = tempj
		if j <= gap then
		    exit
		end if
		j -= gap
	    end while
	    x[j] = tempi
	end for
	if gap = 1 then
	    return x
	else
	    gap = floor(gap / 3.5) + 1
	end if
    end while
end function

integer c   --no need to re-create it every time
function srt(sequence s1,sequence s2)
--sorts sequences, actually pairs.
--sorts by descending second elements, and ascending first elements on ties
c=compare(s1[2],s2[2])
if c then return -c
else return compare(s1[1],s2[1])
end if
end function
constant SORT2=routine_id("srt")   --custom_sort will use this

--unique words recogniser
sequence hashed                                             --hash table, to determine if a word is new and log it afap
constant best_hash_len=20, chunk_h=repeat(0,best_hash_len)  --avoid dynamic allocations amap
constant hash_size=20*'Z'                                   --bucket number
hashed=repeat({chunk_h,chunk_h},hash_size)                  --hash value is the sum of normalised chars (no quotes, no lowercase)
sequence hashlen hashlen=repeat(0,hash_size)                --bucket current sizes
sequence hashmax hashmax=repeat(best_hash_len,hash_size)    --bucket max sizes
integer hashval                                             --scratchpad for hash key for current token

--for progressive memory allocation to <uniques>
constant chunk=20000,chunk_s=repeat({"",0,0},chunk), chunk_i=repeat(0,chunk)
integer max_unique max_unique=chunk                         --current size of uniques

--structures for requested outputs
sequence uniques uniques=chunk_s                            --unique {word,freq,id} repository
sequence lfreqs lfreqs=repeat(0,20)                         --word length freq
sequence id2rk id2rk=chunk_i                                --id->rank converter
integer unique unique=0                                     --#unique words
integer totalwords totalwords=0                             --#words

--character classification
constant END=-2,DELIM=-1,NOWORD=0,QUOTES=1,WORD=2,DIGIT=2,LETTER=3,HYPHEN=4
--for consistency, state and char types have the same name when applicable:
--END: not a char, marks EoL
--DELIM: inside a delimiter/delimiter char
--NOWORD: a token that's been discarded as a valid word
--QUOTES: a token starting with a quote/a quote char
--WORD: a possibly valid token
--DIGIT: a digit char
--LETTER: a letter char
--HYPHEN: a hyphen char
constant chartype=repeat(DELIM,'\''-1)&QUOTES&repeat(DELIM,'-'-'\''-1)&HYPHEN  --except ' and -,all delimiters
                 &repeat(DELIM,'0'-'-'-1)&repeat(DIGIT,10) &repeat(DELIM,'A'-'9'-1)  --all delimiters except the 10 digits
                 &repeat(LETTER,26)&repeat(DELIM,'a'-'Z'-1)&repeat(LETTER,26) --all letters, except just a few
                 &repeat(DELIM,127-'z')   --all delimiters too
                 &repeat(DELIM,128)  --rules say that's not needed,but just in case...
                 &END
constant nochar=256,     --value of first non character, would be 128 in theory.
         norm='a'-'A'    --used to convert lowercase to uppercase
--anyway, nochar is the one and only index such that chartype[nochar]=END

--scanning tools
object x                --reads in gets(filehandle)
sequence data           --holds current physical line
integer index           --scans <data>
integer state           --automaton state
integer char,           --current raw character
        typechar,       --character class as per above
        wordstart,      --current word start
        wordlen,        --recorded word length <=20
        hasqletter,     --1 if a quote or a letter appeared in current token
        readhyphen,     --1 if hyphen just read inside a word
        lastquote,      --index to copy current group to, if there was an inside quote, or 0
        startgroup      --start of current group to copy to lastquote, if there's an inside quote
--when a word stops, it was normalised during the scanning process: all uppercase, held in a contiguous slice of <data>
sequence word           --holds new completed word to process

--unique words list management
constant sortperiod=3000,morethantopdisplayed=30
integer counter counter=sortperiod
--every few thousands unique words, the top 30 entries in <uniques> are repopulated with the top 30 unique words by frequency.
--that's why an id->rank converter is needed, so as not to fetch things in the hash table
sequence tops   --used to sort the top elements during the periodical rearranging of uniques.
                --holds top unique words appropriately sorted on exit

function bfind(sequence what,sequence s)    --binary tree rank search
--s is a sequences of sequences, the call_func() inside compares them with p
--p is less than s[$] for this func
--seq1<seq2 means s1[2]>s2[2], or = and s1[1]<s2[1] as strings
integer lbound,hbound,newbound,c
if call_func(SORT2,{s[1],what})>=0 then return 1 end if
lbound=1 hbound=morethantopdisplayed  --which is length(s)
--assert s[lbound]<what<s[hbound]
while 1 do
   newbound=floor((lbound+hbound)/2)
   c=call_func(SORT2,{s[newbound],what})  --why is it faster than inlining???
   if c=0 then return newbound
   elsif c=-1 then lbound=newbound
   else hbound=newbound
   end if
   if hbound=lbound+1 then return hbound end if   --hbound-lbound>1 ==> new_hbound-new_lbound >=1 and hbound>newbound>lbound
end while
end function

--all purpose scratchpad vars
integer p,p1,p2
sequence s

--now open file to process
constant c0=command_line(),c1=c0[3],c2=open(c1,"r")
--if c2=-1 then puts(2,"File  "&c1&" couldn't be opened, bailing out.") abort(-1) end if
--if c2=-1 then gets() will crash, don't bother
while 1 do
  x=gets(c2)            --gets current physical line
  if atom(x) then exit
  else data=x & nochar  --avoids countless tests for end of string
  end if
  state=DELIM           --a start of line is like any block of whitespace
  index=1
  while 1 do            --start line scan
     char=data[index]
     typechar=chartype[char]
     --start of finite automaton with 3+6 states and 6 input types
     --the 6 substates for WORD are hyphen last read or not (2)*(3) fragmenting level of current token
     --that level is either: lastquote=startgroup=0 (none)
                           --lastquote>0=groupstart (defragmented)
                           --lastquote>0<groupstart (fragmented)
--most frequent states placed in the code so as to minimize the number of tests

     if state=WORD then
       if wordlen=20 and typechar>QUOTES then state=NOWORD   --token too long

       elsif typechar<=DELIM and
        (hasqletter=0 or readhyphen or wordlen>20) then      --token too long, ends with hyphen or no quote/letter
           if typechar=DELIM then state=DELIM
           else exit
           end if

       elsif typechar>=DIGIT then
           if typechar=LETTER then
              hasqletter=1
              if char>='a' then data[index]-=norm end if
           end if
           wordlen+=1
           hashval+=data[index]
           if lastquote and startgroup=0 then         --start of next group to be moved
               startgroup=index
           end if
           if typechar=HYPHEN then
              readhyphen=1
              while data[index+1]='-' do index+=1 wordlen+=1 end while
              if wordlen>20 then state=NOWORD end if  --token too long
           else readhyphen=0
           end if                                     --otherwise, it's a valid char, and we know there was a hyphen last read

       else                                           --QUOTES,DELIM,END; wordlen may be 20 if QUOTES
           if lastquote and startgroup then  --move the group, it ends here
             p=index-startgroup  --group length
             data[lastquote..lastquote+p-1]=data[startgroup..index-1]  --move to contiguous location
             lastquote+=p                                              --next copy position
             startgroup=0                                              --no group to move
           end if
           if typechar!=QUOTES then  --true end of word: the end-of-token tests where all passed before getting there
             word=data[wordstart..wordstart+wordlen-1]  --that was the purpose of moving groups around
             lfreqs[wordlen]+=1                         --word length freqs update
             totalwords+=1                              --total word tally update
             p=find(word,hashed[hashval][1])            --that sequence shouldn't be too long, so that this is fast
             if p then   --word already known              --actually, hash redirection is slower
                p1=hashed[hashval][2][p]
                           --get the word identifier ([2]) at the right place ([p])
                           --from relevant bucket ([hashval]) in hash table <hashed>,
                uniques[id2rk[p1]][2]+=1
                           --then convert it to an index in <uniques> (id2rk[p1]),
                           --and update uniques[this_index][2]
  --
             else    --new, heretofore unknown word, update all kinds of lists
                hashlen[hashval]+=1        --relevant bucket length update
                unique+=1    --unique word tally update
                p=hashlen[hashval]          --current last used index in this bucket
                s=hashed[hashval]           --for faster handling
                s[1][p]=word
                s[2][p]=unique
                if p=hashmax[hashval] then  --bucket may grow further, get more RAM
                   s[1]&=chunk_h
                   s[2]&=chunk_h
                   hashmax[hashval]+=best_hash_len
                end if
                hashed[hashval]=s
                uniques[unique]={word,1,unique}
                id2rk[unique]=unique
                if unique=max_unique then   --more room for unique words?
                  uniques&=chunk_s
                  id2rk&=chunk_i
                  max_unique+=chunk
                end if
                counter-=1
                if counter=0 then           --perform a quasi sort of <uniques>
                  counter=sortperiod        --ie the 20+ most frequent words must lie in the same area of uniques
                  tops=custom_sort(SORT2,uniques[1..morethantopdisplayed])
         --update id2rk, which is the inverse permutation of uniques[][3]
                  for i=1 to morethantopdisplayed do id2rk[tops[i][3]]=i end for
                  while 1 do
                    p1=morethantopdisplayed+1
                    p2=tops[morethantopdisplayed][2]
                    while p1<=unique and uniques[p1][2]<=p2 do p1+=1 end while
                    if p1>unique then exit end if
                    p=bfind(uniques[p1],tops)
         --shift tops from p+1 1 place to the right, inserting the new value and sending the minimal ejected element to uniques[p1]
                    s=uniques[p1]
                    uniques[p1]=tops[morethantopdisplayed]
                    tops[p+1..morethantopdisplayed]=tops[p..morethantopdisplayed-1]
                    tops[p]=s
         --update id2rk accordingly
                    for i=p to morethantopdisplayed do id2rk[tops[i][3]]=i end for
                    id2rk[uniques[p1][3]]=p1
                  end while
                  uniques[1..morethantopdisplayed]=tops
                end if
             end if
             if typechar=DELIM then state=DELIM              --quite obvious
             else exit
             end if
           else    --quote read in WORD state
              if lastquote=0 then lastquote=index end if     --first inside quote
              readhyphen=0
              while data[index+1]='\'' do index+=1 end while -->>next non quote
           end if
       end if
--other less frequent states
     elsif state=DELIM then
         if typechar=HYPHEN then state=NOWORD  --token starts with hyphen
         elsif typechar>QUOTES then  --***     --could be the start of a word: LETTER or DIGIT
            state=WORD
            hasqletter=(typechar=LETTER)
            wordstart=index                    --if it's a word, it starts here
            wordlen=1
            lastquote=0                        --no inside quote (yet)
            startgroup=0
            if char>='a' then data[index]-=norm end if   --normalise char
            readhyphen=0                       --in WORD state, <readhyphen> records the last char read being a hyphen
            hashval=data[index]                -- 0 + 1st char
         elsif typechar=END then exit          --EoL
         elsif typechar=QUOTES then            --token starts with a quote, there'll be  a specific check
            state=QUOTES
            wordstart=index
            wordlen=0
            while data[index+1]='\'' do index+=1 end while   -->> next non quote
         end if                                --do nothing if DELIM in a DELIM state

     elsif state=NOWORD then                   --just go to the end of the non word token
         if typechar=DELIM then state=DELIM
         elsif typechar=END then exit
         end if

     elsif state=QUOTES then                   --word started with a 1 quote or more
         if typechar=DELIM then state=DELIM    --token had only quotes, not a word
         elsif typechar=END then exit          --EoL
         else                                  --not a quote, must be >=WORD
            state=WORD                         --could be a word, same as *** above, except that there may be a hyphen
            hasqletter=1                       --inside quotes are recorded using lastquote
            wordstart=index
            wordlen=1
            lastquote=0
            startgroup=0
            if char>='a' then data[index]-=norm readhyphen=0
            else readhyphen=(typechar=HYPHEN)
            end if
            hashval=data[index]
         end if
     end if
     index+=1  --next char
  end while
  --exit in the loop above means: index already points to a new char and needs no update
end while

--word length frequencies are in lfreqs, unique=#unique words
tops=custom_sort(SORT2,uniques[1..morethantopdisplayed])
while 1 do   --run this, as uniques won't get updated any more
             --see ** above, but don't care for id2rk
  p1=morethantopdisplayed+1
  p2=tops[morethantopdisplayed][2]
  while p1<=unique and uniques[p1][2]<=p2 do p1+=1 end while
  if p1>unique then exit end if
  p=bfind(uniques[p1],tops)
  s=uniques[p1]
  uniques[p1]=tops[morethantopdisplayed]
  tops[p+1..morethantopdisplayed]=tops[p..morethantopdisplayed-1]
  tops[p]=s
end while
--tops holds the 20+x sorted unique top words
--get #word length frequencies to display in lfreqs
p1=20
while lfreqs[p1]=0 do p1-=1 end while

--count how many of them to display
p=floor(unique/1000)+1    --#unique words to display
if p>20 then p=20 end if

--we can get rid of hash*.*, uniques,id2rk
--this could take some time: let the OS care, after elapsed time is computed

--output data in requested format to console, which was just opened, so that there's no need to clear_screen(), position() etc
puts(1,"Christian Cuvier "&c1&'\n')  --that's yellow on blue
printf(1,"Total: %7d, Unique: %7d\n",{totalwords,unique})
for i=1 to p do
  printf(1,"%02d %-20s %d\n",{i,tops[i][1],tops[i][2]})
end for
for i=1 to p1 do
  printf(1,"%02d %d\n",{i,lfreqs[i]})
end for
printf(1, "Elapsed time: %f\n", time() - START)
--p=machine_func(26,0)   --wait_key() for testing purposes
