-------------------------------------------------------------------------------
--Name: mrtrick_v2.ex
--Author: MrTrick
--Date:  3/11/2004
--Version: 1.2 - Production
-------------------------------------------------------------------------------
--This program has been created in a modular fashion - the parser and 
--aggregator are separated so that they can be enhanced without affecting
--version control. 
-------------------------------------------------------------------------------
--Usage: exwc mrtrick_v2.ex $filename
-------------------------------------------------------------------------------

constant START = time()
-------------------------------------------------------------------------------
without type_check
without warning
--<WORD PARSER>================================================================
include parser_v4.e     --Use this version of the parser code
open_file()             --Open the file, ready to be read.

--<AGGREGATOR, RANKING>========================================================
include aggregator_v5.e --Use this version of the aggregator code

--<PRINTING>===================================================================
--Display the results of the analysis
printf(1, "Patrick Barnes %s\n", {file_name})
printf(1, "Total: %7d, Unique: %7d\n", {word_total, unique_total})
--Show the most commonly occuring words
for i = 1 to RANK_SIZE do
    printf(1, "%02d %-20s %d\n", {i, top_words[i][WORD], -top_words[i][FREQ]} )
end for
--Show the occurences of each size of word
for i = 1 to LONGEST_WORD do 
    printf(1, "%02d %d\n", {i, totals_by_length[i]} )
end for
-------------------------------------------------------------------------------
printf(1, "Elapsed time: %f\n", time() - START)
------------------------------------------------------------------------------